lastWeaponEnt <- null;

//Weapon Template:
//  names = ["alias1", "alias2"],
//  displayname = "Display Name",
//  baseclass = "tf_weapon_shovel",
//  baseid = 6,
//  animmodel = "models/weapons/v_models/v_crowbar_mercenary.mdl",
//  weaponmodel = "models/weapons/c_models/c_crowbar.mdl",
//  OnEquip = function(player, weaponTT, weaponEnt) { }
//  OnSwitch = function(player, weaponTT, weaponEnt) { }

AddTimer(-1, -10, function ()
{
    local weaponEnt = self.GetActiveWeapon();

    if (weaponEnt == lastWeaponEnt)
        return;
    lastWeaponEnt = weaponEnt;
    if (!weaponEnt)
        return;

    local weaponScript = weaponEnt.GetScriptScope();
    if ("OnSwitch" in weaponScript)
        weaponScript.OnSwitch(self, weaponScript.weaponTT, weaponEnt);
    if ("weaponTT" in weaponScript)
        RefreshModels();
});

function CreateWeapon(weaponTT)
{
    local weaponEnt = Entities.CreateByClassname(weaponTT.baseclass);
    SetPropInt(weaponEnt, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", weaponTT.baseid);
    SetPropBool(weaponEnt, "m_AttributeManager.m_Item.m_bInitialized", true);
    SetPropBool(weaponEnt, "m_bValidatedAttachedEntity", true);
	SetPropBool(weaponEnt, "m_bClientSideAnimation", true);
    weaponEnt.SetTeam(self.GetTeam());
    weaponEnt.SetOwner(self);
	SetPropEntity(weaponEnt, "m_hOwnerEntity", self);
    SetPropBool(weaponEnt, "m_bForcePurgeFixedupStrings", true);
    Entities.DispatchSpawn(weaponEnt);
    return weaponEnt;
}

function EquipWeapon(weaponTT)
{
    local weaponEnt = CreateWeapon(weaponTT);
    self.Weapon_Equip(weaponEnt);
    if ("OnEquip" in weaponTT)
        weaponTT.OnEquip(self, weaponTT, weaponEnt);

    if ("animmodel" in weaponTT)
    {
        weaponEnt.SetModelSimple(weaponTT.animmodel);
        weaponEnt.SetCustomViewModelModelIndex(GetModelIndex(weaponTT.animmodel));
        SetPropInt(weaponEnt, "m_iViewModelIndex", GetModelIndex(weaponTT.animmodel));
    }

    weaponEnt.ValidateScriptScope();
    weaponEnt.GetScriptScope().weaponTT <- weaponTT;
    if ("OnSwitch" in weaponTT)
        weaponEnt.GetScriptScope().OnSwitch <- weaponTT.OnSwitch;
    return weaponEnt;
}