//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

canBePicked <- true;

OnCustomEvent("vip_death", 0, function(player, params)
{
    if (GetFakeTeam(player) == GetFakeTeam(self))
        Enable();
});

function CaneThink()
{
    if (canBePicked)
        PickUpTick();
    return 0.1;
}

function PickUpTick()
{
    local frame = GetPropInt(self, "m_ubInterpolationFrame");
    self.SetAbsAngles(self.GetAbsAngles() + QAngle(0, 10, 0));
    SetPropInt(self, "m_ubInterpolationFrame", frame);

    local myPos = self.GetOrigin();
    foreach(player in GetAlivePlayers())
    {
        if (GetFakeTeam(player) != GetFakeTeam(self))
            continue;
        if ((myPos - player.GetCenter()).Length() < 75)
        {
            Disable();
            main_script.ConvertToVIP(player);
            DoEntFire(GetFakeTeamName(player) + "_vip_spawn*", "Trigger", "", -1, player, player);
            return;
        }
    }
}

function OnPostSpawn()
{
    local teamMembers = ShuffleArray(GetPlayersByFakeTeam(GetFakeTeam(self)));
    local newVIP = teamMembers.len() > 0 ? teamMembers[0] : null;
    if (!newVIP || isDebug)
    {
        Enable();
        return;
    }

    Disable();
    main_script.ConvertToVIP(newVIP);
    DoEntFire(GetFakeTeamName(newVIP) + "_vip_spawn*", "Trigger", "", -1, newVIP, newVIP);
}

function Enable()
{
    canBePicked = true;
    self.SetSkin(GetFakeTeam(self) - 2);
    self.EnableDraw();
    Nag();

    EntFireByHandle(SpawnEntityFromTable("info_particle_system",
    {
        origin = self.GetOrigin() - Vector(0, 0, 20),
        effect_name = "spellbook_major_burning",
        start_active = 1
    }), "SetParent", "!activator", -1, self, self);
}

function Disable()
{
    canBePicked = false;
    self.DisableDraw();
    local entsToKill = [];
    for (local child = self.FirstMoveChild(); child != null; child = child.NextMovePeer())
        entsToKill.push(child);
    foreach (ent in entsToKill)
        ent.Kill();
}

function Nag()
{
    RunWithDelay(10, function()
    {
        if (!canBePicked)
            return;
        local teammateBits = 1;
        foreach(player in GetAllPlayers())
        {
            if (GetFakeTeam(player) == GetFakeTeam(self))
                teammateBits = teammateBits | (1 << player.entindex());
        }
        local myPos = self.GetOrigin() + Vector(0, 0, 30);
        SendGlobalGameEvent("show_annotation",
        {
            worldPosX = myPos.x,
            worldPosY = myPos.y,
            worldPosZ = myPos.z,
            id = 124,
            text = "Touch the Cane to become the VIP!",
            lifetime = 6,
            visibilityBitfield = teammateBits,
            play_sound = "ui/hint.wav"
        });
        Nag();
    });
}