//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

IncludeScript("vip/gamemode/util.nut");
IncludeScript("vip/gamemode/gamerules.nut");
IncludeScript("vip/gamemode/capture_point_filtering.nut");
IncludeScript("vip/gamemode/attack_defend.nut");
IncludeScript("vip/gamemode/vip_character_fixes.nut");
IncludeScript("vip/gamemode/vip_weapons.nut");

::team_round_timer <- Entities.FindByClassname(null, "team_round_timer");
::canes <- [null, null, null, null, null];
::vipPlayers <- [null, null, null, null, null];

::GetValidVIP <- function(team)
{
    local vip = vipPlayers[team];
    return IsValidPlayer(vip) ? vipPlayers[team] : null;
}

::GetValidVIPs <- function()
{
    local vips = [];
    foreach (vip in vipPlayers)
    {
        if (IsValidPlayer(vip))
            vips.push(vip);
    }
    return vips;
}

::GetFakeTeam <- function(player) //Foreshadowing...
{
    return player.GetTeam();
}

::GetFakeTeamName <- function(player)
{
    local fakeTeam = GetFakeTeam(player);
    return fakeTeam == 2 ? "RED" : fakeTeam == 3 ? "BLU" : "UNKNOWN";
}

::IsTeammateOrSpy <- function(playerA, playerB) //Foreshadowing...
{
    return GetFakeTeam(playerA) == GetFakeTeam(playerB) || GetPropInt(playerB, "m_Shared.m_nDisguiseTeam") == playerA.GetTeam();
}

::IsVIP <- function(player)
{
    if (!player)
        return false;
    foreach (vip in vipPlayers)
        if (player == vip)
            return true;
    return false;
}

function SpawnRedCaneAt(targetname)
{
    SpawnCaneAt(2, targetname);
}

function SpawnBlueCaneAt(targetname)
{
    SpawnCaneAt(3, targetname);
}
SpawnBluCaneAt <- SpawnBlueCaneAt;

function SpawnCaneAt(team, targetname)
{
    SpawnCaneAtEntity(team, Entities.FindByName(null, targetname));
}

function SpawnCaneAtEntity(team, entity)
{
    if (!entity || !entity.IsValid())
        return;
    if (canes[team] && canes[team].IsValid())
    {
        canes[team].Teleport(true, entity.GetOrigin(), false, QAngle(), false, Vector());
    }
    else
    {
	    canes[team] = SpawnEntityFromTable("prop_dynamic",
	    {
        	origin = entity.GetOrigin(),
            angles = "-20 0 0",
            model = API_GetString("cane_pickup_model"),
            vscripts = "vip/entities/cane_pickup.nut",
            thinkfunction = "CaneThink",
	        playbackrate = 1.0,
            TeamNum = team
        });
    }
};

function ConvertToVIP(player)
{
    local team = GetFakeTeam(player);
    vipPlayers[team] = player;
    ConvertToCustomCharacter(player, "vip/vip/_vip.nut");
}