//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

//₁₂₃₄₅₆₇₈₉₀
//¹²³⁴⁵⁶⁷⁸⁹⁰
::big2small <- {
    " ": " ", //" "
    "r": "✔",
    "1": "¹",
    "2": "²",
    "3": "³",
    "4": "⁴",
    "5": "⁵",
    "6": "⁶",
    "7": "⁷",
    "8": "⁸",
    "9": "⁹",
    "0": "⁰",
};
::isRoundSetup <- true;

::BigToSmallNumbers <- function(input)
{
    if (input < 10)
        input = "0" + input;
    else
        input = ""+input
    local result = ".";
    foreach (char in input)
        result += big2small[char.tochar()];
    return result;
}

::ShootGibs <- function(origin, ...)
{
    local gibSpawner = SpawnEntityFromTable("env_shooter",
    {
        origin = origin,
        angles = "-90 0 0",
        spawnflags = 5,
        m_iGibs = 1,
        m_flVelocity = 200,
        scale = 1,
        m_flVariance = 1,
        m_flGibLife = 5,
        shootsounds = 3,
        simulation = 1,
        skin = 1,
        nogibshadows = true
    })
    for (local i = vargv.len() - 1; i >= 0; i--)
    {
        EntFireByHandle(gibSpawner, "AddOutput", "shootmodel " + vargv[i], 0.1 * i, null, null);
        EntFireByHandle(gibSpawner, "Shoot", "", 0.1 * i, null, null);
    }
    EntFireByHandle(gibSpawner, "Kill", "", 2, null, null);
}

::IsRoundSetup <- function()
{
    return isRoundSetup;
}

OnGameEvent("teamplay_setup_finished", function()
{
    isRoundSetup = false;
})

::GetPlayersByFakeTeam <- function(fakeTeam)
{
    local allPlayers = [];
    for (local i = 1; i <= MAX_PLAYERS; i++)
    {
        local player = PlayerInstanceFromIndex(i);
        if (player && GetFakeTeam(player) == fakeTeam)
            allPlayers.push(player);
    }
    return allPlayers;
}