//=========================================================================
//If this is in a Workshop build, please let us know.
//This isn't supposed to happen.
//=========================================================================

//This way we avoid resetting the mp_timeleft timer when mp_restartgame_immediate happens
if (!GetPersistentVar("m_flMapResetTime", null))
    SetPersistentVar("m_flMapResetTime", GetPropFloat(tf_gamerules, "m_flMapResetTime"));
else
    SetPropFloat(tf_gamerules, "m_flMapResetTime", GetPersistentVar("m_flMapResetTime"));

game_text_debug <- SpawnEntityFromTable("game_text",
{
    color = "236 227 203",
    color2 = "0 0 0",
    channel = 1,
    holdtime = 5,
    message = "",
    spawnflags = 1
    x = -1,
    y = 0.65
});

::debug_dot <- 0;
::debug_mdot <- 0;
::debug_dotC <- 0;
::debug_dotC2 <- 0;
::debug_distance <- 0;
::debug_radius <- 0;

/*AddTimer(-1, 0, function()
{
    if (debug_dotC <= 0.625)
        EntFireByHandle(game_text_debug, "AddOutput", "color 0 255 0", 0, null, null);
    else if (debug_dotC2 <= 0.42)
        EntFireByHandle(game_text_debug, "AddOutput", "color 255 255 0", 0, null, null);
    else
        EntFireByHandle(game_text_debug, "AddOutput", "color 236 227 203", 0, null, null);

    EntFireByHandle(game_text_debug "AddOutput",
    "message dot∶ " + debug_dot
        +"\nmdot∶ " + debug_mdot
        +"\ndotC∶ " + debug_dotC
        +"\ndotC2∶ " + debug_dotC2
        +"\ndistance∶ " + debug_distance
        +"\nradius " + debug_radius, 0, null, null);
    EntFireByHandle(game_text_debug "Display", "", 0, self, self);
});*/

OnGameEvent("player_say", 0, function(player, params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    local steamId = NetProps.GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]" && steamId != "[U:1:464940145]" && steamId != "[U:1:839712142]" && steamId != "[U:1:71264411]")
        return;

    if (params.text.find("chance_ally") == 1)
    {
        token_drop_chance_ally = params.text.slice(12).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "token_drop_chance_ally = " + token_drop_chance_ally);
    }
    else if (params.text.find("test5") == 1)
    {
        foreach(item in player.GetWeaponsAndCosmetics())
            printl(item)
    }
    else if (params.text.find("chance_enemy") == 1)
    {
        token_drop_chance_enemy = params.text.slice(13).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "token_drop_chance_enemy = " + token_drop_chance_enemy);
    }
    else if (params.text.find("chance_empty") == 1)
    {
        token_drop_chance_empty = params.text.slice(13).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "token_drop_chance_empty = " + token_drop_chance_empty);
    }
    else if (params.text.find("token_start") == 1)
    {
        vipBoostTokensStart = params.text.slice(12).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "vipBoostTokensStart = " + vipBoostTokensStart);
    }
    else if (params.text.find("death_penalty") == 1)
    {
        death_penalty = params.text.slice(14).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "death_penalty = " + death_penalty);
    }

    if (params.text.find("vip") == 1 || params.text.find("setvip") == 1)
    {
        local pos = params.text.find("vip") == 1 ? 5 : 8;
        local arg = params.text.len() <= pos ? "" : params.text.slice(pos).tolower();
        if (arg == "" || arg == "self" || arg == "!self")
        {
            ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "To you: Next VIP will be "+NetProps.GetPropString(player, "m_szNetname"));
            SetPersistentVar("next_vip", player);
        }
        else
        {
            foreach (otherPlayer in GetValidClients())
            {
                if (otherPlayer.GetTeam() == TF_TEAM_BLUE && NetProps.GetPropString(otherPlayer, "m_szNetname").tolower().find(arg) != null)
                {
                    ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "To you: Next VIP will be "+NetProps.GetPropString(otherPlayer, "m_szNetname"));
                    SetPersistentVar("next_vip", otherPlayer);
                    break;
                }
            }
        }
    }

    if (params.text.find("killvip") == 1)
    {
        local vip = GetValidVIP(TF_TEAM_BLUE);
        vip.TakeDamageEx(
            vip,
            vip,
            vip.GetActiveWeapon(),
            Vector(0, 0, 0),
            vip.GetOrigin(),
            9999,
            0);
    }

    if (params.text.find("!restart") == 0)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
    }
});

::PrintEntity <- function(entity)
{
    local tempTable = {}
    NetProps.GetTable(entity, 1, tempTable)

    if(tempTable != null){
        printl("---------- START DATAMAP DUMP FOR " + entity + " ----------")
        foreach (k,v in tempTable){
            printl(k+" -> "+v)
        }
        printl("----------  END DATAMAP DUMP FOR " + entity + "  ----------")
    }
}

::FindTheLizard <- function()
{
    local maxPlayers = MaxClients().tointeger();
    for (local i = 1; i <= maxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (!player)
            continue;
        local steamId = NetProps.GetPropString(player, "m_szNetworkIDString");
        if (steamId == "[U:1:61845546]")
            return player;
    }
    return null;
}

if (IsDedicatedServer())
seterrorhandler(function (e)
{
    printl(e)
    local lizard = FindTheLizard();
    local Chat = @(m) ClientPrint(lizard, 3, m)
    Chat(format("\nAN ERROR HAS OCCURRED [%s]", e))
    Chat("CALLSTACK")
    local s, l = 2
    while (s = getstackinfos(l++))
        Chat(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    Chat("LOCALS")
    if (s = getstackinfos(2))
        foreach (n, v in s.locals) {
            local t = type(v)
            t ==    "null" ? Chat(format("[%s] NULL"  , n))    :
            t == "integer" ? Chat(format("[%s] %d"    , n, v)) :
            t ==   "float" ? Chat(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? Chat(format("[%s] \"%s\"", n, v)) :
                             Chat(format("[%s] %s %s" , n, t, v.tostring()))
        }
})

/*::ForfutureUse <-  function(player, model)
{
    local bot = SpawnEntityFromTable("prop_dynamic",
    {
        model = model,
        origin = player.GetOrigin(),
        health = 9999999999,
    });

    bot.SetMoveType(0, 0);
    bot.SetSolid(0);
    NetProps.SetPropInt(bot, "m_fEffects", 129);
    NetProps.SetPropInt(bot, "m_nNextThinkTick", 0x7FFFFFFF);
    //EntFireByHandle(bot, "Disable", "", -1, null, null);
    EntFireByHandle(bot, "SetParent", "!activator", -1, player, null);
    return bot;
}
*/